<?php

	// Perform Login
    $CURRENT_MODULE_KEY = 'record_job_order_task';
    $SHORTCODE_STATUS = PHPCUS_SHORTCODE::CUS_QUICK_LOGIN();
	
	// Check nonce
	if($SHORTCODE_STATUS == false)
    {
		PHPCUS_PARAM::CUS_REQUIRES_NONCE();
	}
	
	// Check array size
	PHPCUS_PARAM::CUS_ARRAY_TOO_LARGE();
	
	// Check already authenticated
	PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();

	// Check access rights
	PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_EDIT, $CURRENT_MODULE_KEY);
	
	if
	(
			PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
			(
					[
							'PARAM_REC_JORDER_TASK_ID',
							'PARAM_REC_JORDER_TASK_DESCRIPTION', 
							'PARAM_REC_JORDER_TASK_REMARKS', 
							'PARAM_REC_JORDER_TASK_QTY_TARGET', 
							'PARAM_REC_JORDER_TASK_QTY_ACTUAL', 
							'PARAM_REC_JORDER_TASK_AMT_TARGET', 
							'PARAM_REC_JORDER_TASK_AMT_ACTUAL', 
							'PARAM_REC_JORDER_TASK_LONG_A', 
							'PARAM_REC_JORDER_TASK_LONG_B', 
							'PARAM_REC_JORDER_TASK_DECIMAL_A', 
							'PARAM_REC_JORDER_TASK_DECIMAL_B', 
							'PARAM_REC_JORDER_TASK_VARCHAR_A', 
							'PARAM_REC_JORDER_TASK_VARCHAR_B', 
							'PARAM_REC_JORDER_TASK_DATETIME_A', 
							'PARAM_REC_JORDER_TASK_DATETIME_B', 
							'PARAM_REC_JORDER_TASK_STATUS'
							// , 'PARAM_REC_JORDER_TASK_ID_FILE'
					], True
			)
	)
	{
		Try
		{
			// Read params
			// ------------------------------------------------------------------
			$PARAM_REC_JORDER_TASK_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_ID', true);
			$PARAM_REC_JORDER_TASK_DESCRIPTION = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_DESCRIPTION', true);
			$PARAM_REC_JORDER_TASK_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_REMARKS', true);
			$PARAM_REC_JORDER_TASK_QTY_TARGET = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_QTY_TARGET', true);
			$PARAM_REC_JORDER_TASK_QTY_ACTUAL = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_QTY_ACTUAL', true);
			$PARAM_REC_JORDER_TASK_AMT_TARGET = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_AMT_TARGET', true);
			$PARAM_REC_JORDER_TASK_AMT_ACTUAL = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_AMT_ACTUAL', true);
			$PARAM_REC_JORDER_TASK_LONG_A = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_LONG_A', true);
			$PARAM_REC_JORDER_TASK_LONG_B = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_REC_JORDER_TASK_LONG_B', true);
			$PARAM_REC_JORDER_TASK_DECIMAL_A = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_DECIMAL_A', true);
			$PARAM_REC_JORDER_TASK_DECIMAL_B = PHPCUS_PARAM::CUS_READ_DECIMAL('PARAM_REC_JORDER_TASK_DECIMAL_B', true);
			$PARAM_REC_JORDER_TASK_VARCHAR_A = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_VARCHAR_A', true);
			$PARAM_REC_JORDER_TASK_VARCHAR_B = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REC_JORDER_TASK_VARCHAR_B', true);
			$PARAM_REC_JORDER_TASK_DATETIME_A = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_JORDER_TASK_DATETIME_A', true);
			$PARAM_REC_JORDER_TASK_DATETIME_B = PHPCUS_PARAM::CUS_READ_DATETIME('PARAM_REC_JORDER_TASK_DATETIME_B', true);
			$PARAM_REC_JORDER_TASK_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_REC_JORDER_TASK_STATUS', true);
			
			//$PARAM_REC_JORDER_TASK_ID_FILE = PHPCUS_PARAM::CUS_READ_FILES('PARAM_REC_JORDER_TASK_ID_FILE');
			$PARAM_ARRAY_COUNT = count($PARAM_REC_JORDER_TASK_ID);
			
				
			// Validate if array has same size
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_ARRAY_SIZE_MISMATCH
			(
					[
							$PARAM_REC_JORDER_TASK_ID,
							$PARAM_REC_JORDER_TASK_DESCRIPTION, 
							$PARAM_REC_JORDER_TASK_REMARKS, 
							$PARAM_REC_JORDER_TASK_QTY_TARGET, 
							$PARAM_REC_JORDER_TASK_QTY_ACTUAL, 
							$PARAM_REC_JORDER_TASK_AMT_TARGET, 
							$PARAM_REC_JORDER_TASK_AMT_ACTUAL, 
							$PARAM_REC_JORDER_TASK_LONG_A, 
							$PARAM_REC_JORDER_TASK_LONG_B, 
							$PARAM_REC_JORDER_TASK_DECIMAL_A, 
							$PARAM_REC_JORDER_TASK_DECIMAL_B, 
							$PARAM_REC_JORDER_TASK_VARCHAR_A, 
							$PARAM_REC_JORDER_TASK_VARCHAR_B, 
							$PARAM_REC_JORDER_TASK_DATETIME_A, 
							$PARAM_REC_JORDER_TASK_DATETIME_B, 
							$PARAM_REC_JORDER_TASK_STATUS
							// ,$PARAM_REC_JORDER_TASK_ID_FILE['name']
					]
			);
			

			// Abort if already processed
			// ------------------------------------------------------------------
			$PARAM_REQUEST_UNIQUE_VALUE = null;
			if(PHPRC_HTTP_PARAM::REF_ISSET('PARAM_REQUEST_UNIQUE_VALUE'))
			{
			    $PARAM_REQUEST_UNIQUE_VALUE = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_REQUEST_UNIQUE_VALUE', false);
			}
			
			if(PHPVC_STR::VAR_IS_BLANK($PARAM_REQUEST_UNIQUE_VALUE) == false)
			{
			    $ARR_INDEX = array_search($CURRENT_MODULE_KEY, PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY);
			    if
			    (
			        $ARR_INDEX !== false &&
			        PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE[$ARR_INDEX] == $PARAM_REQUEST_UNIQUE_VALUE
			        )
			    {
			        PHPCUS_PARAM::CUS_JSON_ERROR('Given Request is already processed.');
			    }
			}
			
			
			// Prepare PDO Handler
			// ------------------------------------------------------------------
			$FULL_DATA_SET = [];
			$ARRAY_CTR = 0;
			
			$SAVE_MAP_ARRAY = [];
			$PDO_HANDLE = PHPRC_PDO_MYSQL::REF_CONNECT();
			PHPRC_PDO_MYSQL::REF_TRANSACTION_BEGIN($PDO_HANDLE);
			
		
			// Execute Stored Procedure
			// ------------------------------------------------------------------
			Try
			{
				while($ARRAY_CTR < $PARAM_ARRAY_COUNT)
				{
					$SAVE_MAP_ARRAY = PHPCUS_RECORD_JOB_ORDER_TASK::CUS_PREPARE_MAPPED_ARRAY_FOR_SAVE();
					
					$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_ID'] = $PARAM_REC_JORDER_TASK_ID[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_DESCRIPTION'] = $PARAM_REC_JORDER_TASK_DESCRIPTION[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_REMARKS'] = $PARAM_REC_JORDER_TASK_REMARKS[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_QTY_TARGET'] = $PARAM_REC_JORDER_TASK_QTY_TARGET[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_QTY_ACTUAL'] = $PARAM_REC_JORDER_TASK_QTY_ACTUAL[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_AMT_TARGET'] = $PARAM_REC_JORDER_TASK_AMT_TARGET[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_AMT_ACTUAL'] = $PARAM_REC_JORDER_TASK_AMT_ACTUAL[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_LONG_A'] = $PARAM_REC_JORDER_TASK_LONG_A[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_LONG_B'] = $PARAM_REC_JORDER_TASK_LONG_B[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_DECIMAL_A'] = $PARAM_REC_JORDER_TASK_DECIMAL_A[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_DECIMAL_B'] = $PARAM_REC_JORDER_TASK_DECIMAL_B[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_VARCHAR_A'] = $PARAM_REC_JORDER_TASK_VARCHAR_A[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_VARCHAR_B'] = $PARAM_REC_JORDER_TASK_VARCHAR_B[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_DATETIME_A'] = $PARAM_REC_JORDER_TASK_DATETIME_A[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_DATETIME_B'] = $PARAM_REC_JORDER_TASK_DATETIME_B[$ARRAY_CTR];
$SAVE_MAP_ARRAY['PARAM_REC_JORDER_TASK_STATUS'] = $PARAM_REC_JORDER_TASK_STATUS[$ARRAY_CTR];
							
					$DATA_SET = PHPCUS_RECORD_JOB_ORDER_TASK::CUS_SAVE_MA
					(
							$SAVE_MAP_ARRAY,
							true,
							$PDO_HANDLE
					);
			
					/*
					if
					(
						isset($PARAM_REC_FILEDIR_ID_FILE['name'][$ARRAY_CTR]) && 
						empty($DATA_SET) == false && 
						isset($DATA_SET[0]['INSERTED_ID'])
					)
					{		
						$FILE_PATH = PHPRC_UPLOAD::REF_SUGGEST_PATH
						(
							PHPSET::$ROOT . '/upload/priv/Record/job_order_task/', 
							$DATA_SET[0]['INSERTED_ID'],
							$PARAM_REC_JORDER_TASK_ID_FILE
						);
						PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_MOVEFILE
						(
							$PARAM_REC_JORDER_TASK_ID_FILE['tmp_name'],
							$FILE_PATH,
							true
						);
					}
					*/
					
					$FULL_DATA_SET = PHPRC_PDO_MYSQL_ARRAY::REF_MERGE($FULL_DATA_SET, $DATA_SET);
					$ARRAY_CTR ++;
				}
					
			}
			Catch(Exception $PDO_ERR)
			{
				PHPRC_PDO_MYSQL::REF_TRANSACTION_ROLLBACK($PDO_HANDLE);
				//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_ROLLBACK();
				PHPCUS_PARAM::CUS_JSON_ERROR($PDO_ERR);
			}
			PHPRC_PDO_MYSQL::REF_TRANSACTION_COMMIT($PDO_HANDLE);
			//PHPRC_UPLOAD::REF_UPLOAD_TRANSACTION_COMMIT();
						
			
			// Update processed request key
			// ------------------------------------------------------------------
			if(PHPVC_STR::VAR_IS_BLANK($PARAM_REQUEST_UNIQUE_VALUE) == false)
			{
			    $ARR_INDEX = array_search($CURRENT_MODULE_KEY, PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY);
			    if($ARR_INDEX !== false)
			    {
			        PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE[$ARR_INDEX] = $PARAM_REQUEST_UNIQUE_VALUE;
			    }
			    else
			    {
			        array_push(PHPCUS_Account_Login_Session::$SESSION_REQUEST_KEY, $CURRENT_MODULE_KEY);
			        array_push(PHPCUS_Account_Login_Session::$SESSION_REQUEST_LAST_VALUE, $PARAM_REQUEST_UNIQUE_VALUE);
			    }
			}	
			
			
			// Return JSON response
			// ------------------------------------------------------------------
			PHPCUS_PARAM::CUS_JSON_SUCCESS($FULL_DATA_SET);
			
		}
		Catch(Exception $ERR)
		{
			PHPCUS_PARAM::CUS_JSON_ERROR($ERR);
		}
	}
	else
	{
		PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
	}

?>